unit psPickDate;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, Calendar, ComCtrls, DsgnIntf, ExtCtrls;

type
  { TPickDateDlg }
  TPickDateDlg = class(TForm)
    OKButton: TButton;
    CancelButton: TButton;
    PickDateGroup: TGroupBox;
    MonthLabel: TLabel;
    YearLabel: TLabel;
    MonthCombo: TComboBox;
    YearEdit: TEdit;
    YearSelector: TUpDown;
    DateSelector: TCalendar;
    procedure MonthComboChange(Sender: TObject);
    procedure YearEditExit(Sender: TObject);
    procedure YearSelectorChanging(Sender: TObject; var AllowChange: Boolean);
  public
    function Execute(var Day, Month, Year: Word): Boolean;
  end;

implementation

{$R *.DFM}

const
  MaxDays : Array[0..11] of Word = (31,28,31,30,31,30,31,31,30,31,30,31);

{ ------------------------------------------------------------------------------------------------
  TPickDateDlg
  ------------------------------------------------------------------------------------------------ }
function TPickDateDlg.Execute(var Day, Month, Year: Word): Boolean;
begin
  { Initialize all controls }
  DateSelector.Day      := Day;
  DateSelector.Month    := Month;
  DateSelector.Year     := Year;
  MonthCombo.ItemIndex  := Month-1;
  YearSelector.Position := Year;

  { If the dialog is executed successfully, return the values }
  if ShowModal = mrOK then begin
    Result := True;
    Day    := DateSelector.Day;
    Month  := DateSelector.Month;
    Year   := DateSelector.Year;
  end else
    Result := False;
end;

procedure TPickDateDlg.MonthComboChange(Sender: TObject);
begin
  { Change the month. Watch out for the maximum number of days for each month }
  if DateSelector.Day > MaxDays[MonthCombo.ItemIndex] then
    DateSelector.Day := MaxDays[MonthCombo.ItemIndex];
  DateSelector.Month := MonthCombo.ItemIndex+1;
end;

procedure TPickDateDlg.YearEditExit(Sender: TObject);
var
  i: Integer;
begin
  { Change the Year }
  try
    i := StrToInt(YearEdit.Text);
    YearSelector.Position := i;
    DateSelector.Year     := YearSelector.Position;
  except
    YearEdit.Text := IntToStr(YearSelector.Position);
  end;
end;

procedure TPickDateDlg.YearSelectorChanging(Sender: TObject; var AllowChange: Boolean);
begin
  { Change the Year }
  DateSelector.Year       := YearSelector.Position;
end;

end.
